window.test = {};
var DN = window.DN = {};
var execTimeObj = {};
window.NATIVE_CALLBACK = {};
var originModules = window.JSBridge;
if (!Object.keys) {
  Object.keys = (function() {
    'use strict';
    var hasOwnProperty = Object.prototype.hasOwnProperty,
        hasDontEnumBug = !({ toString: null }).propertyIsEnumerable('toString'),
        dontEnums = [
          'toString',
          'toLocaleString',
          'valueOf',
          'hasOwnProperty',
          'isPrototypeOf',
          'propertyIsEnumerable',
          'constructor'
        ],
        dontEnumsLength = dontEnums.length;

    return function(obj) {
      if (typeof obj !== 'function' && (typeof obj !== 'object' || obj === null)) {
        throw new TypeError('Object.keys called on non-object');
      }

      var result = [], prop, i;

      for (prop in obj) {
        if (hasOwnProperty.call(obj, prop)) {
          result.push(prop);
        }
      }

      if (hasDontEnumBug) {
        for (i = 0; i < dontEnumsLength; i++) {
          if (hasOwnProperty.call(obj, dontEnums[i])) {
            result.push(dontEnums[i]);
          }
        }
      }
      return result;
    };
  }());
}

if (!Array.prototype.reduce) {
  Object.defineProperty(Array.prototype, 'reduce', {
    value: function(callback) {
      if (this === null) {
        throw new TypeError( 'Array.prototype.reduce ' +
          'called on null or undefined' );
      }
      if (typeof callback !== 'function') {
        throw new TypeError( callback +
          ' is not a function');
      }

      var o = Object(this);

      var len = o.length >>> 0;

      var k = 0;
      var value;

      if (arguments.length >= 2) {
        value = arguments[1];
      } else {
        while (k < len && !(k in o)) {
          k++;
        }

        if (k >= len) {
          throw new TypeError( 'Reduce of empty array ' +
            'with no initial value' );
        }
        value = o[k++];
      }

      while (k < len) {
        if (k in o) {
          value = callback(value, o[k], k, o);
        }

        k++;
      }

      return value;
    }
  });
}





function createCb (method, callbacks) {
  var cb = window.NATIVE_CALLBACK;
  var funPath = 'NATIVE_CALLBACK.' + method;

  var methodCb = cb[method];
  if(Object.prototype.toString.call(methodCb) !== '[object Object]') {
    window.NATIVE_CALLBACK[method] = methodCb = {};
  }

  var execTime = execTimeObj[method];
  if(execTime) {
    execTime++
  } else {
    execTime = 1;
  }
  execTimeObj[method] = execTime;

  return Object.keys(callbacks).reduce((obj, key) => {
    var targetKey = key + execTime;

    window.NATIVE_CALLBACK[method][targetKey] = methodCb[targetKey] = function (resp) {
      callbacks[key](resp);
    };
    obj[key] = funPath + '.' + targetKey;
    return obj;
  }, {});
}

function nativeRun (method, args) {
  var resolve = args.success || function() {},
      reject = args.error || function() {},
      params = args.params || {};

  var custom = Object.keys(args).reduce((obj, key) => {
    const fun = args[key];
    if (fun != null && fun instanceof Function) {
      obj[key] = fun;
    }
    return obj;
  }, {});


  var originCb = {
    success: resolve,
    error: reject,
  };
  for(var attr in custom) {
    originCb[attr] = custom[attr];
  }

  var nativeCb = createCb(method, originCb);
  for (var key in nativeCb) {
    args[key] = nativeCb[key];
  }

  if(!originModules[method]) {
    throw new Error('hi man：' + method + ' was not found');
  }
  originModules[method](JSON.stringify(args))
}

function hanldeModule () {
  Object.keys(originModules).forEach(handler => {
    DN[handler] = function(args) {
      return nativeRun(handler, args || {});
    }
  })
}

hanldeModule();
var doc = document;
var readyEvent = doc.createEvent('Events');
readyEvent.initEvent('JsBridgeReady');
readyEvent.bridge = DN;
doc.dispatchEvent(readyEvent);
